package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserAddress;
import com.izouma.awesomeadmin.service.UserAddressService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/userAddress")
@RequiresAuthentication
public class UserAddressController {

    @Autowired
    private UserAddressService userAddressService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserAddress record) {
        List<UserAddress> pp = userAddressService.getUserAddressList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getUserAddress", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserAddress(@RequestParam(required = false, value = "id") String id) {
        UserAddress data = userAddressService.getUserAddressById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserAddress record) {
        UserAddress data = userAddressService.getUserAddress(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserAddress record) {
        Map<String, Object> result = new HashMap<>();

        List<UserAddress> pp = userAddressService.getUserAddressByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserAddress record) {
        boolean num = userAddressService.createUserAddress(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserAddress(UserAddress record) {
        boolean num = userAddressService.updateUserAddress(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserAddress(@RequestParam(required = true, value = "id") String id) {

        boolean num = userAddressService.deleteUserAddress(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserAddress record) throws Exception {

        List<UserAddress> userAddresss = userAddressService.getUserAddressList(record);


        String sheetName = "user_address";
        String titleName = "用户收货地址数据表";
        String fileName = "用户收货地址表";
        int columnNumber = 13;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "用户ID", "收货人", "电话", "邮编", "地址", "详细地址", "默认"};
        String[][] dataList = new String[userAddresss.size()][13];

        for (int i = 0; i < userAddresss.size(); i++) {

            dataList[i][0] = String.valueOf(userAddresss.get(i).getId());
            dataList[i][1] = String.valueOf(userAddresss.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(userAddresss.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(userAddresss.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(userAddresss.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(userAddresss.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(userAddresss.get(i).getUserId());
            dataList[i][7] = String.valueOf(userAddresss.get(i).getRealName());
            dataList[i][8] = String.valueOf(userAddresss.get(i).getTelephone());
            dataList[i][9] = String.valueOf(userAddresss.get(i).getPostcode());
            dataList[i][10] = String.valueOf(userAddresss.get(i).getAddress());
            dataList[i][11] = String.valueOf(userAddresss.get(i).getAddressDetail());
            dataList[i][12] = String.valueOf(userAddresss.get(i).getDefaultFlag());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }


    @RequestMapping(value = "/setDefault", method = RequestMethod.POST)
    @ResponseBody
    public Result setDefault(@RequestParam(required = true, value = "userId") String userId,
                             @RequestParam(required = true, value = "addressId") String addressId) {

        boolean num = userAddressService.setDefaultUserAddress(userId, addressId);
        if (num) {
            return new Result(true, "设置默认成功");
        }
        return new Result(false, "设置默认地址异常");
    }

}

